﻿//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
//  Primitive zur Ansteuerung einer achtstelligen 7-Segment-Anzeige                     //
//  _____________________________________________________                               //
//                                                                                      //
//  Copyright © 2016 Reimar Grasbon (softwork@grasbon.de)                               //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
//  This software is subjected to the FreeBSD License. Redistribution and use in source //
//  and binary forms, with or without modification, are permitted provided that the     //
//  following conditions are met:                                                       //
//                                                                                      //
//  1. Redistributions of source code must retain the above copyright notice, this list //
//     of conditions and the following disclaimer.                                      //
//                                                                                      //
//  2. Redistributions in binary form must reproduce the above copyright notice, this   //
//     list of conditions and the following disclaimer in the documentation and/or      //
//     other materials provided with the distribution.                                  //
//                                                                                      //
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY //
//  EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED           //
//  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  //
//  IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,    //
//  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT  //
//  NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR  //
//  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,   //
//  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)  //
//  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE          //
//  POSSIBILITY OF SUCH DAMAGE.                                                         //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////

#pragma once

#include "Conf.h"
#include "TypeDefs.h"
#include "String.h"

//////////////////////////////////////////////////////////////////////////////////////////
//  Definitionen  ////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
#define  DISPLAY_PrintLit(_t_)  DISPLAY_PrintP(PSTR(_t_))

//////////////////////////////////////////////////////////////////////////////////////////
//  Typen  ///////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
typedef enum
{   ANIM_TWISTING_DIGITS =  0,
    ANIM_ALARM_ENABLE    =  1,
    ANIM_ALARM_DISABLE   =  2,
    ANIM_ALARM           =  3,
    ANIM_ALARM_PAUSE     =  4,
    ANIM_GOTO_SLEEP      =  5,
    ANIM_RADIO_ON        =  6,
    ANIM_RADIO_OFF       =  7,
    ANIM_MENU_OPEN       =  8,
    ANIM_MENU_CLOSE      =  9,
    ANIM_SETTINGS_OPEN   = 10,
    ANIM_SETTINGS_CLOSE  = 11,
    ANIM_NONE
} Animation;

//////////////////////////////////////////////////////////////////////////////////////////
// Funktionen  ///////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
void       DISPLAY_Enable(bool);
bool       DISPLAY_IsEnabled(void);
void       DISPLAY_SetBrightness(SInt08);
SInt08     DISPLAY_Brightness(void);
void       DISPLAY_SetSegment(UInt08, UInt08);
void       DISPLAY_SetDot(UInt08, bool);
void       DISPLAY_Clear(void);
void       DISPLAY_Print(const String*);
void       DISPLAY_PrintP(const char*);
void       DISPLAY_StartAnim(Animation);
void       DISPLAY_StopAnim(void);
Animation  DISPLAY_CurrentAnim(void);
void       DISPLAY_SetBlinkingDigits(UInt08);

//////////////////////////////////////////////////////////////////////////////////////////
//  System  //////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
void       DISPLAY_Startup(void);
void       DISPLAY_Proceed(void);
void       DISPLAY_Shutdown(void);

//////////////////////////////////////////////////////////////////////////////////////////

